unit parser;
interface

const
 nlex=12; {㯭 㭪樨}
 lexems: array [1..nlex] of string =(
 'sin','cos','arctan','sqr','sqrt','exp','ln','abs','trunc','frac','round',
 'pi'
);
 max=80; {.᫮ ᥬ}
 maxlen=10; {. ᥬ}
var lex:array[1..max] of string[maxlen]; {ᥬ}
    types:array[1..max] of char; {⨯ ᥬ}
    numbers:array[1..max] of real; {᫠  }
    clex:integer; {⥪饥 ᫮ ᥬ}
    runerror:string; {訡 ६ ᯮ}

function lowcase (s:string):string;
function alltrim (s:string):string;
function check (var s:string;var e:string):boolean;
function eval (x:real;var r:real):boolean;
function parse (s:string; x:real; var e:string):real;

implementation

function lowcase (s:string):string; { ॣ}
var l,i,c:integer;
begin
 l:=length(s);
 for i:=1 to l do begin
  c:=ord(s[i]);
  if (c>=ord('A')) and (c<=ord('Z')) or
     (c>=ord('')) and (c<=ord(''))
   then inc (c,32)
  else if (c>=ord('')) and (c<=ord(''))
   then inc(c,80);
  s[i]:=chr(c);
 end;
 lowcase:=s;
end;

function alltrim (s:string):string; { ஡}
var p:integer;
begin
 repeat
  p:=pos(' ',s);
  if p>0 then delete (s,p,1);
 until p=0;
 alltrim:=s;
end;

procedure pack_lexems (n1,n2:integer;x:real); {㯠 ᨢ ᥬ}
var i,k:integer; st:string[maxlen];
begin
 if (n1>n2) or (n1<1) or (n2>clex) then exit;
 k:=n2-n1;
 for i:=n2+1 to clex do begin
  lex[i-k]:=lex[i];
  types[i-k]:=types[i];
  numbers[i-k]:=numbers[i];
 end;
 str(x:maxlen,st);{筮}
 numbers[n1]:=x;{⮬  }
 lex[n1]:=st;
 types[n1]:='n';
 dec(clex,k);
end;

function number (n1:integer;x:real):real; {ࠡ⪠ ᫠}
var r:real; er:integer;
begin
 if (types[n1]='f') and (lex[n1]='pi') then r:=pi
 else if types[n1]='x' then r:=x
 else begin
  if abs(numbers[n1])>1E-8 then r:=numbers[n1] {筠  ᫠}
  else begin
   val(lex[n1],r,er);
   if er<>0 then begin
    runerror:=' ᫠:'+lex[n1];
    r:=0;
   end;
  end;
 end;
 number:=r;
end;

function number_skob (n1:integer;x:real):real; {᫮  ᪮}
var r:real;
begin
 r:=number(n1+1,x);
 pack_lexems (n1,n1+2,r);
 number_skob:=r;
end;

function do_oper (n:integer;x:real):real; {᫥ 䬥⨪}
var r:real;
begin
 if lex[n]='*' then r:=number(n-1,x)*number(n+1,x)
 else if lex[n]='/' then begin
  r:=number(n+1,x);
  if r=0 then begin
   runerror:='  0';
   r:=0;
  end
  else r:=number(n-1,x)/r;
 end
 else if lex[n]='+' then r:=number(n-1,x)+number(n+1,x)
 else if lex[n]='-' then r:=number(n-1,x)-number(n+1,x);
 pack_lexems (n-1,n+1,r);
 do_oper:=r;
end;

procedure pack_number_sign (i:integer;x:real); {  ᫠  .i}
var k:integer; r:real;
begin
 k:=0;
 if lex[i]='+' then k:=1
 else if lex[i]='-' then k:=-1;
 if k<>0 then begin
  r:=k*number (i+1,x);
  pack_lexems (i,i+1,r);
 end;
end;

function oper (n1:integer;x:real):real; {䬥᪨ 樨}
label again;
var i:integer; r:real;
begin
again:
 for i:=1 to clex do begin {㡨ࠥ "譨"  +,-  ᫠}
  if (types[i]='o') and ((lex[i]='+') or (lex[i]='-')) then begin
   if (i=1) and ((types[2]='x') or (types[2]='n'))
      or (
      (i<clex) and
      ((types[i+1]='x') or (types[i+1]='n')) and
      ((types[i-1]='(') or (types[i+1]='o'))
      ) then begin
    pack_number_sign (i,x);
   end;
  end;
 end;
 if (lex[n1]='(') and (lex[n1+2]=')') then begin {᫠  ()}
  oper:=number(n1+1,x);
  exit;
 end
 else begin
  i:=n1+1;
  while (types[i]<>')') and (i<=clex) do begin
   if (lex[i]='*') or (lex[i]='/') then begin {* , /}
    do_oper (i,x);
    goto again; { ࠧ  "稥"  +,-}
   end
   else inc(i);
  end;
  i:=n1+1;
  while (types[i]<>')') and (i<=clex) do begin
   if (lex[i]='+') or (lex[i]='-') then begin {+ , -}
    do_oper (i,x);
    goto again;
   end
   else inc(i);
  end;
  if (lex[i-2]='(') and (lex[i]=')') then begin {⠫ (x)}
   oper:=number(i-1,x);
   exit;
  end
  else if clex=1 then begin {⠫ x}
   oper:=number(1,x);
   exit;
  end;
  {-x,+x    - ࠭ }
 end;
end;

function func(f:string;n1:integer;x:real):real; {⠭ 㭪樨}
var r,r2:real;
begin
 r:=oper(n1,x);
 if f='sin' then begin
  r2:=sin(r);
 end
 else if f='cos' then begin
  r2:=cos(r);
 end
 else if f='arctan' then begin
  r2:=arctan(r);
 end
 else if f='sqr' then begin
  r2:=sqr(r);
 end
 else if f='sqrt' then begin
  if r<0 then begin
   runerror:='७  ⥫쭮 ᫠: '+f;
   r2:=0;
  end
  else r2:=sqrt(r);
 end
 else if f='exp' then begin
  if abs(r)>88 then begin
   runerror:='९: '+f;
   r2:=0;
  end
  else r2:=exp(r);
 end
 else if f='ln' then begin
  if r<=0 then begin
   runerror:='  ᫠<=0: '+f;
   r2:=0;
  end
  else r2:=ln(r);
 end
 else if f='abs' then begin
  r2:=abs(r);
 end
 else if f='trunc' then begin
  r2:=trunc(r);
 end
 else if f='frac' then begin
  r2:=frac(r);
 end
 else if f='round' then begin
  r2:=round(r);
 end;
 pack_lexems (n1-1,n1+2,r2);
 func:=r2;
end;

function find_oper (n1:integer):integer; { .ࠦ  . n1}
var n2,k:integer;
begin
 n2:=n1+1; k:=0;
 repeat
  if types[n2]=')' then break;
  if not ( (types[n2]='n') or (types[n2]='x') or (types[n2]='o') or
     (types[n2]='f') and (lex[n2]='pi') ) then inc(k);
  inc(n2);
 until n2=clex;
 if k=0 then find_oper:=n2
 else find_oper:=0;
end;

function skobka (n1:integer;x:real):real; {ࠧ 㣫 ᪮}
var n2,k,er:integer; r:real;
begin
 n2:=n1+1; k:=0;
 repeat
  if types[n2]='(' then r:=skobka(n2,x);
  if types[n2]=')'then begin
   if k=0 then break;
   dec(k);
  end;
  inc(n2);
  if n2=clex then break;
 until false;
 {  ᠬ ७ ᪮}
 if n1>1 then begin
  if types[n1-1]='f' then begin
   r:=func(lex[n1-1],n1,x);
  end
  else begin
   n2:=find_oper(n1);
   if n2<>0 then r:=oper(n1,x);
  end;
 end
 else begin
  n2:=find_oper(n1);
  if n2<>0 then r:=oper(n1,x);
 end;
 if (types[n1]='(') and (types[n1+2]=')') then begin
  skobka:=number_skob(n1,x);
  exit;
 end;
end;

function kol_items (c:char):integer; {- ᥬ ⨯=c}
var i,k:integer;
begin
 k:=0;
 for i:=0 to clex do if types[i]=c then inc(k);
 kol_items:=k;
end;

function eval (x:real;var r:real):boolean; { 㭪 業}
begin runerror:='';
 repeat
  r:=skobka (1,x);
  if runerror<>'' then begin
   eval:=false; exit;
  end;
 until kol_items ('(')=0;
 r:=oper(1,x);
 if runerror<>'' then begin
  eval:=false; exit;
 end;
 eval:=true;
end;

function check_rool(pred,cur:char;lexem0,lexem1:string):boolean;
 {஢ઠ ࠢ ᫥ ᥬ}
begin
 check_rool:=false;
 case pred of
  'S': begin
   if (cur='f') or (cur='n') or (cur='x') or (cur='(') or
      (cur='o') and ((lexem1='-') or (lexem1='+')) then check_rool:=true;
  end;
  'f': begin
   if lexem0<>'pi' then begin
    if cur='(' then check_rool:=true;
   end
   else begin
    if (cur='o') or (cur=')') then check_rool:=true;
   end;
  end;
  'n': begin
   if (cur='o') or (cur=')') or (cur='E') then check_rool:=true;
  end;
  'o': begin
   if (cur='n') or (cur='x') or (cur='(')  or (cur='f') then check_rool:=true;
  end;
  'x': begin
   if (cur='o') or (cur=')') or (cur='E') then check_rool:=true;
  end;
  '(': begin
   if (cur='x') or (cur='f') or (cur='n') or (cur='(') or
      (cur='o') and ((lexem1='+') or (lexem1='-')) then check_rool:=true;
  end;
  ')': begin
   if (cur=')') or (cur='o') or (cur='E') then check_rool:=true;
  end;
 end;
end;

function get_lexem_arrays (s,s0:string;var e:string):boolean;
 {祭 ᨢ ᥬ}
var type0,type1:char;
 l,start1,end1:integer;
 lexem0,lexem1:string;
begin
 s0:=s0+'E';
 type0:='S';
 type1:=s0[1];
 l:=length(s);
 start1:=1;
 clex:=0;
 lexem0:='';
 while start1<=l do begin
  end1:=start1;
  if (s0[end1]='(') or (s0[end1]=')') then inc(end1)
  else begin
   while s0[end1]=type1 do begin
    if end1>l then break;
    inc(end1);
   end;
  end;
  lexem1:=copy(s,start1,end1-start1);
  if length(lexem1)>maxlen then begin
   e:='誮  ᥬ: '+lexem1;
   get_lexem_arrays:=false; exit;
  end;
  if (check_rool(type0,type1,lexem0,lexem1)=false) then begin
   e:='ୠ ᫥⥫쭮 ⢨: '+copy(s,start1,l-start1);
   get_lexem_arrays:=false; exit;
  end;
  inc(clex);
  lex[clex]:=lexem1;
  lexem0:=lexem1;
  types[clex]:=type1;
  type0:=type1;
  type1:=s0[start1+length(lexem1)];
  inc(start1,length(lexem1));
  {writeln (lex[clex],' ',types[clex]);}
 end;
 lexem0:=lexem1;
 lexem1:='';
 if (check_rool(type0,type1,lexem0,lexem1)=false) then begin
  e:='୮ ᫥ ⢨';
  get_lexem_arrays:=false; exit;
 end;
 get_lexem_arrays:=true;
end;

function replace_strings (sold,snew:string;var s:string):integer;
 { sold  snew  ப s; ୥ ᫮ }
var n,p:integer;
begin
 n:=0;
 repeat
  p:=pos(sold,s);
  if p>0 then begin
   delete (s,p,length(sold));
   insert (snew,s,p);
   inc(n);
  end;
 until p=0;
 replace_strings:=n;
end;

function check (var s:string;var e:string):boolean;
 { 㭪 ஢ન}
label next_i;
var l,k,k0,i,j,r:integer;
 n:real;
 s0,s1:string;
begin
 l:=length(s);
 k:=0;
 {஫ ᪮}
 for i:=1 to l do begin
  if s[i]='(' then inc (k)
  else if s[i]=')' then dec(k);
  if k<0 then begin
   e:=': '+copy(s,i,l-i+1);
   check:=false; exit;
  end;
 end;
 if k<>0 then begin
  e:=' ᪮';
  check:=false; exit;
 end;
 {ࠡ 楯窨  +,-}
 repeat
  k:=0;
  inc(k,replace_strings ('++','+',s));
  inc(k,replace_strings ('--','+',s));
  inc(k,replace_strings ('+-','-',s));
  inc(k,replace_strings ('-+','-',s));
 until k=0;
 {砫 ࠧ  ᥬ}
 l:=length(s);
 s0:='';
 for i:=1 to l do s0:=concat(s0,' ');
 { ᫠}
 i:=1;
next_i:
 while i<=l do begin
  for j:=l downto i do begin
   s1:=copy (s,i,j-i+1);
   val (s1,n,r);
   if r=0 then begin
    for k:=i to j do begin
     s0[k]:='n';
    end;
    if (s[i]='+') or (s[i]='-') then begin {譨 +  -  ᥫ}
     if (i>1) and (s[i-1]<>'+') and (s[i-1]<>'-') and (s[i-1]<>'(') then
      s0[i]:='o';
    end;
    i:=j+1;
    goto next_i;
   end;
  end;
  inc (i);
 end;
 {⠢ ᪮, 樨}
 k:=0;
 for i:=1 to l do begin
  case s[i] of
   '+','-': if (s0[i]<>'n') then s0[i]:='o';
   '*','/': s0[i]:='o';
   '(',')': s0[i]:=s[i];
  end;
 end;
 {⠭ 㭪樨}
 k:=-1;
 repeat
  k:=pos(' ',s0);
  if k>0 then begin
   j:=k;
   while s0[k]=' ' do begin
    inc(k);
    if k>l then break;
   end;
   s1:=copy (s,j,k-j);
   k0:=0;
   for i:=1 to nlex do begin
    if lexems[i]=s1 then begin
     for r:=j to k-1 do s0[r]:='f';
     k0:=1;
     break;
    end;
   end;
   if k0=0 then for r:=j to k-1 do s0[r]:='_';
  end
 until k=0;
 {㬥}
 for i:=1 to l do if (s[i]='x') and (s0[i]='_') then s0[i]:='x';
 {⠢訥 楯窨 }
 for i:=1 to l do if (s0[i]='_') then begin
  e:='⭠ ᥬ: '+copy(s,i,l-i+1);
  check:=false; exit;
 end;
 {writeln(s0);}
 {ࠢ ᥬ}
 if (get_lexem_arrays (s,s0,e)=false) then begin
  check:=false; exit;
 end;
 check:=true;
end;

function parse (s:string; x:real; var e:string):real;
 { 㭪 ᥣ }
var r:real; i:integer;
begin
 e:='';
 s:=alltrim(lowcase(s));
 if length(s)<1 then begin
  e:='訡: ப ';
  parse:=0; exit;
 end;
 if check(s,e)=true then begin
  for i:=1 to clex do numbers[i]:=0;
  if eval(x,r)=true then begin
   parse:=r;
   exit;
  end
  else e:='訡 ᫥: '+runerror;
 end
 else e:='訡 ࠧ: '+e;
end;

begin
end.